import type { GeneratedSchema, RevertSchema, SchemaExport } from './../types.js';
import { SchemaNode } from '../node.js';
import { Permit } from './permit.js';
export declare class SchemaBranch<T extends GeneratedSchema> {
    readonly $schema: T;
    private _meta;
    constructor(schema: T, scope?: string, spacer?: string);
    toJSON(): unknown;
    get $meta(): {
        scope: string;
        spacer: string;
    };
    get $scope(): string;
    $each(nodeHook: (node: SchemaNode, key: string) => void, branchHook?: (branch: SchemaBranch<any>, key: string) => void): void;
    $refactor(prefix?: string, spacer?: string): void;
    $export(): {
        schema: SchemaExport<T>;
        meta: {
            scope: string;
            spacer: string;
        };
    };
    $model(): RevertSchema<T>;
    $permit(scopes: (string | SchemaNode)[]): Permit<T>;
}
