import type { SchemaScope } from './types.js';
export declare class SchemaNode {
    /** Generated string scope */
    $scope: string;
    /** Description for the string scope */
    $description: string;
    /**
     * overriding json stringify
     *
     * @see https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/JSON/stringify#tojson_behavior
     */
    toJSON(): unknown;
    constructor(scope: string, description: string);
}
export declare class PermitNode extends SchemaNode {
    /** access control value for scope */
    private $value;
    /** hook function for subscribing to scope changes */
    private $subscriber;
    constructor(schema: SchemaNode, value?: boolean);
    /** helper for broadcasting changes to subscriber */
    private _broadcast;
    toJSON(): {
        scope: string;
        description: string;
        value: boolean;
    };
    /** readonly boolean value of true on disabled */
    get $disable(): boolean;
    /** boolean value of the scope. will broadcast changes when assigned new value to event listener. */
    get $able(): boolean;
    /** boolean value of the scope. will broadcast changes when assigned new value to event listener. */
    set $able(value: boolean);
    /** add listener function to scope that called on value changes */
    $subscribe(fn: (active: boolean, scope: SchemaScope) => void): () => boolean;
    /** utility for toggling value. will broadcast changes every call to event listener. */
    $toggle(): void;
}
