import { SchemaBranch } from './branch/schema.js';
import { SchemaNode } from './node.js';
import type { SchemaTree, TransformSchema } from './types.js';
/**
 * traverse given schema tree by recursive loop
 * then call hook onLeaf on every leaf node
 * and onBranch on every branch node.
 */
export declare function traverseTree<T extends SchemaTree>(node: T, parent?: string, spacer?: string, onLeaf?: (node: string, scope: string, parent: string) => void, onBranch?: (node: SchemaTree, scope: string, parent: string) => void): void;
/**
 * transform given schema tree by recursive loop
 * then on every leaf transform leaf node using onLeaf hook.
 */
export declare function transformTree<A extends SchemaTree, T>(nodes: A, parent: string, spacer: string | undefined, onLeaf: (node: string, scope: string, parent: string) => T): TransformSchema<A, T>;
export declare const makeScope: (spacer: string, paths: string[]) => string;
export declare const keySafe: (key: string | symbol | number) => boolean;
export declare const loopSchema: <T extends {
    [x: string]: SchemaNode;
}>(schema: T, onNode: (node: SchemaNode, key: string) => void, onBranch: (node: SchemaBranch<any>, key: string) => void) => void;
